
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Comparisons" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="field" use="required" type="{http://www.dmg.org/PMML-4_1}FIELD-NAME" />
 *       &lt;attribute name="isCenterField" default="true">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *             &lt;enumeration value="true"/>
 *             &lt;enumeration value="false"/>
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *       &lt;attribute name="fieldWeight" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" default="1" />
 *       &lt;attribute name="similarityScale" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="compareFunction" type="{http://www.dmg.org/PMML-4_1}COMPARE-FUNCTION" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "comparisons"
})
@XmlRootElement(name = "ClusteringField")
public class ClusteringField
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "Comparisons")
    protected Comparisons comparisons;
    @XmlAttribute(name = "field", required = true)
    protected FieldName field;
    @XmlAttribute(name = "isCenterField")
    protected ClusteringField.CenterField isCenterField;
    @XmlAttribute(name = "fieldWeight")
    protected Double fieldWeight;
    @XmlAttribute(name = "similarityScale")
    protected Double similarityScale;
    @XmlAttribute(name = "compareFunction")
    protected CompareFunctionType compareFunction;

    @Deprecated
    public ClusteringField() {
        super();
    }

    public ClusteringField(final FieldName field) {
        super();
        this.field = field;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the comparisons property.
     * 
     * @return
     *     possible object is
     *     {@link Comparisons }
     *     
     */
    public Comparisons getComparisons() {
        return comparisons;
    }

    /**
     * Sets the value of the comparisons property.
     * 
     * @param value
     *     allowed object is
     *     {@link Comparisons }
     *     
     */
    public void setComparisons(Comparisons value) {
        this.comparisons = value;
    }

    /**
     * Gets the value of the field property.
     * 
     * @return
     *     possible object is
     *     {@link FieldName }
     *     
     */
    public FieldName getField() {
        return field;
    }

    /**
     * Sets the value of the field property.
     * 
     * @param value
     *     allowed object is
     *     {@link FieldName }
     *     
     */
    public void setField(FieldName value) {
        this.field = value;
    }

    /**
     * Gets the value of the isCenterField property.
     * 
     * @return
     *     possible object is
     *     {@link ClusteringField.CenterField }
     *     
     */
    public ClusteringField.CenterField getIsCenterField() {
        if (isCenterField == null) {
            return ClusteringField.CenterField.TRUE;
        } else {
            return isCenterField;
        }
    }

    /**
     * Sets the value of the isCenterField property.
     * 
     * @param value
     *     allowed object is
     *     {@link ClusteringField.CenterField }
     *     
     */
    public void setIsCenterField(ClusteringField.CenterField value) {
        this.isCenterField = value;
    }

    /**
     * Gets the value of the fieldWeight property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public double getFieldWeight() {
        if (fieldWeight == null) {
            return  1.0D;
        } else {
            return fieldWeight;
        }
    }

    /**
     * Sets the value of the fieldWeight property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setFieldWeight(Double value) {
        this.fieldWeight = value;
    }

    /**
     * Gets the value of the similarityScale property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getSimilarityScale() {
        return similarityScale;
    }

    /**
     * Sets the value of the similarityScale property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setSimilarityScale(Double value) {
        this.similarityScale = value;
    }

    /**
     * Gets the value of the compareFunction property.
     * 
     * @return
     *     possible object is
     *     {@link CompareFunctionType }
     *     
     */
    public CompareFunctionType getCompareFunction() {
        return compareFunction;
    }

    /**
     * Sets the value of the compareFunction property.
     * 
     * @param value
     *     allowed object is
     *     {@link CompareFunctionType }
     *     
     */
    public void setCompareFunction(CompareFunctionType value) {
        this.compareFunction = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof ClusteringField)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final ClusteringField that = ((ClusteringField) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            Comparisons lhsComparisons;
            lhsComparisons = this.getComparisons();
            Comparisons rhsComparisons;
            rhsComparisons = that.getComparisons();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "comparisons", lhsComparisons), LocatorUtils.property(thatLocator, "comparisons", rhsComparisons), lhsComparisons, rhsComparisons)) {
                return false;
            }
        }
        {
            FieldName lhsField;
            lhsField = this.getField();
            FieldName rhsField;
            rhsField = that.getField();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "field", lhsField), LocatorUtils.property(thatLocator, "field", rhsField), lhsField, rhsField)) {
                return false;
            }
        }
        {
            ClusteringField.CenterField lhsIsCenterField;
            lhsIsCenterField = this.getIsCenterField();
            ClusteringField.CenterField rhsIsCenterField;
            rhsIsCenterField = that.getIsCenterField();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "isCenterField", lhsIsCenterField), LocatorUtils.property(thatLocator, "isCenterField", rhsIsCenterField), lhsIsCenterField, rhsIsCenterField)) {
                return false;
            }
        }
        {
            double lhsFieldWeight;
            lhsFieldWeight = ((this.fieldWeight!= null)?this.getFieldWeight(): 0.0D);
            double rhsFieldWeight;
            rhsFieldWeight = ((that.fieldWeight!= null)?that.getFieldWeight(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fieldWeight", lhsFieldWeight), LocatorUtils.property(thatLocator, "fieldWeight", rhsFieldWeight), lhsFieldWeight, rhsFieldWeight)) {
                return false;
            }
        }
        {
            Double lhsSimilarityScale;
            lhsSimilarityScale = this.getSimilarityScale();
            Double rhsSimilarityScale;
            rhsSimilarityScale = that.getSimilarityScale();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "similarityScale", lhsSimilarityScale), LocatorUtils.property(thatLocator, "similarityScale", rhsSimilarityScale), lhsSimilarityScale, rhsSimilarityScale)) {
                return false;
            }
        }
        {
            CompareFunctionType lhsCompareFunction;
            lhsCompareFunction = this.getCompareFunction();
            CompareFunctionType rhsCompareFunction;
            rhsCompareFunction = that.getCompareFunction();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "compareFunction", lhsCompareFunction), LocatorUtils.property(thatLocator, "compareFunction", rhsCompareFunction), lhsCompareFunction, rhsCompareFunction)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            Comparisons theComparisons;
            theComparisons = this.getComparisons();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "comparisons", theComparisons), currentHashCode, theComparisons);
        }
        {
            FieldName theField;
            theField = this.getField();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "field", theField), currentHashCode, theField);
        }
        {
            ClusteringField.CenterField theIsCenterField;
            theIsCenterField = this.getIsCenterField();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "isCenterField", theIsCenterField), currentHashCode, theIsCenterField);
        }
        {
            double theFieldWeight;
            theFieldWeight = ((this.fieldWeight!= null)?this.getFieldWeight(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "fieldWeight", theFieldWeight), currentHashCode, theFieldWeight);
        }
        {
            Double theSimilarityScale;
            theSimilarityScale = this.getSimilarityScale();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "similarityScale", theSimilarityScale), currentHashCode, theSimilarityScale);
        }
        {
            CompareFunctionType theCompareFunction;
            theCompareFunction = this.getCompareFunction();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "compareFunction", theCompareFunction), currentHashCode, theCompareFunction);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            Comparisons theComparisons;
            theComparisons = this.getComparisons();
            strategy.appendField(locator, this, "comparisons", buffer, theComparisons);
        }
        {
            FieldName theField;
            theField = this.getField();
            strategy.appendField(locator, this, "field", buffer, theField);
        }
        {
            ClusteringField.CenterField theIsCenterField;
            theIsCenterField = this.getIsCenterField();
            strategy.appendField(locator, this, "isCenterField", buffer, theIsCenterField);
        }
        {
            double theFieldWeight;
            theFieldWeight = ((this.fieldWeight!= null)?this.getFieldWeight(): 0.0D);
            strategy.appendField(locator, this, "fieldWeight", buffer, theFieldWeight);
        }
        {
            Double theSimilarityScale;
            theSimilarityScale = this.getSimilarityScale();
            strategy.appendField(locator, this, "similarityScale", buffer, theSimilarityScale);
        }
        {
            CompareFunctionType theCompareFunction;
            theCompareFunction = this.getCompareFunction();
            strategy.appendField(locator, this, "compareFunction", buffer, theCompareFunction);
        }
        return buffer;
    }


    /**
     * <p>Java class for null.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * <p>
     * <pre>
     * &lt;simpleType>
     *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
     *     &lt;enumeration value="true"/>
     *     &lt;enumeration value="false"/>
     *   &lt;/restriction>
     * &lt;/simpleType>
     * </pre>
     * 
     */
    @XmlType(name = "")
    @XmlEnum
    public enum CenterField {

        @XmlEnumValue("true")
        TRUE("true"),
        @XmlEnumValue("false")
        FALSE("false");
        private final String value;

        CenterField(String v) {
            value = v;
        }

        public String value() {
            return value;
        }

        public static ClusteringField.CenterField fromValue(String v) {
            for (ClusteringField.CenterField c: ClusteringField.CenterField.values()) {
                if (c.value.equals(v)) {
                    return c;
                }
            }
            throw new IllegalArgumentException(v);
        }

    }

}
