
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;choice>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}euclidean"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}squaredEuclidean"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}chebychev"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}cityBlock"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}minkowski"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}simpleMatching"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}jaccard"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}tanimoto"/>
 *           &lt;element ref="{http://www.dmg.org/PMML-4_1}binarySimilarity"/>
 *         &lt;/choice>
 *       &lt;/sequence>
 *       &lt;attribute name="kind" use="required">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *             &lt;enumeration value="distance"/>
 *             &lt;enumeration value="similarity"/>
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *       &lt;attribute name="compareFunction" type="{http://www.dmg.org/PMML-4_1}COMPARE-FUNCTION" default="absDiff" />
 *       &lt;attribute name="minimum" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="maximum" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "euclidean",
    "squaredEuclidean",
    "chebychev",
    "cityBlock",
    "minkowski",
    "simpleMatching",
    "jaccard",
    "tanimoto",
    "binarySimilarity"
})
@XmlRootElement(name = "ComparisonMeasure")
public class ComparisonMeasure
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    protected Euclidean euclidean;
    protected SquaredEuclidean squaredEuclidean;
    protected Chebychev chebychev;
    protected CityBlock cityBlock;
    protected Minkowski minkowski;
    protected SimpleMatching simpleMatching;
    protected Jaccard jaccard;
    protected Tanimoto tanimoto;
    protected BinarySimilarity binarySimilarity;
    @XmlAttribute(name = "kind", required = true)
    protected ComparisonMeasure.Kind kind;
    @XmlAttribute(name = "compareFunction")
    protected CompareFunctionType compareFunction;
    @XmlAttribute(name = "minimum")
    protected Double minimum;
    @XmlAttribute(name = "maximum")
    protected Double maximum;

    @Deprecated
    public ComparisonMeasure() {
        super();
    }

    public ComparisonMeasure(final ComparisonMeasure.Kind kind) {
        super();
        this.kind = kind;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the euclidean property.
     * 
     * @return
     *     possible object is
     *     {@link Euclidean }
     *     
     */
    public Euclidean getEuclidean() {
        return euclidean;
    }

    /**
     * Sets the value of the euclidean property.
     * 
     * @param value
     *     allowed object is
     *     {@link Euclidean }
     *     
     */
    public void setEuclidean(Euclidean value) {
        this.euclidean = value;
    }

    /**
     * Gets the value of the squaredEuclidean property.
     * 
     * @return
     *     possible object is
     *     {@link SquaredEuclidean }
     *     
     */
    public SquaredEuclidean getSquaredEuclidean() {
        return squaredEuclidean;
    }

    /**
     * Sets the value of the squaredEuclidean property.
     * 
     * @param value
     *     allowed object is
     *     {@link SquaredEuclidean }
     *     
     */
    public void setSquaredEuclidean(SquaredEuclidean value) {
        this.squaredEuclidean = value;
    }

    /**
     * Gets the value of the chebychev property.
     * 
     * @return
     *     possible object is
     *     {@link Chebychev }
     *     
     */
    public Chebychev getChebychev() {
        return chebychev;
    }

    /**
     * Sets the value of the chebychev property.
     * 
     * @param value
     *     allowed object is
     *     {@link Chebychev }
     *     
     */
    public void setChebychev(Chebychev value) {
        this.chebychev = value;
    }

    /**
     * Gets the value of the cityBlock property.
     * 
     * @return
     *     possible object is
     *     {@link CityBlock }
     *     
     */
    public CityBlock getCityBlock() {
        return cityBlock;
    }

    /**
     * Sets the value of the cityBlock property.
     * 
     * @param value
     *     allowed object is
     *     {@link CityBlock }
     *     
     */
    public void setCityBlock(CityBlock value) {
        this.cityBlock = value;
    }

    /**
     * Gets the value of the minkowski property.
     * 
     * @return
     *     possible object is
     *     {@link Minkowski }
     *     
     */
    public Minkowski getMinkowski() {
        return minkowski;
    }

    /**
     * Sets the value of the minkowski property.
     * 
     * @param value
     *     allowed object is
     *     {@link Minkowski }
     *     
     */
    public void setMinkowski(Minkowski value) {
        this.minkowski = value;
    }

    /**
     * Gets the value of the simpleMatching property.
     * 
     * @return
     *     possible object is
     *     {@link SimpleMatching }
     *     
     */
    public SimpleMatching getSimpleMatching() {
        return simpleMatching;
    }

    /**
     * Sets the value of the simpleMatching property.
     * 
     * @param value
     *     allowed object is
     *     {@link SimpleMatching }
     *     
     */
    public void setSimpleMatching(SimpleMatching value) {
        this.simpleMatching = value;
    }

    /**
     * Gets the value of the jaccard property.
     * 
     * @return
     *     possible object is
     *     {@link Jaccard }
     *     
     */
    public Jaccard getJaccard() {
        return jaccard;
    }

    /**
     * Sets the value of the jaccard property.
     * 
     * @param value
     *     allowed object is
     *     {@link Jaccard }
     *     
     */
    public void setJaccard(Jaccard value) {
        this.jaccard = value;
    }

    /**
     * Gets the value of the tanimoto property.
     * 
     * @return
     *     possible object is
     *     {@link Tanimoto }
     *     
     */
    public Tanimoto getTanimoto() {
        return tanimoto;
    }

    /**
     * Sets the value of the tanimoto property.
     * 
     * @param value
     *     allowed object is
     *     {@link Tanimoto }
     *     
     */
    public void setTanimoto(Tanimoto value) {
        this.tanimoto = value;
    }

    /**
     * Gets the value of the binarySimilarity property.
     * 
     * @return
     *     possible object is
     *     {@link BinarySimilarity }
     *     
     */
    public BinarySimilarity getBinarySimilarity() {
        return binarySimilarity;
    }

    /**
     * Sets the value of the binarySimilarity property.
     * 
     * @param value
     *     allowed object is
     *     {@link BinarySimilarity }
     *     
     */
    public void setBinarySimilarity(BinarySimilarity value) {
        this.binarySimilarity = value;
    }

    /**
     * Gets the value of the kind property.
     * 
     * @return
     *     possible object is
     *     {@link ComparisonMeasure.Kind }
     *     
     */
    public ComparisonMeasure.Kind getKind() {
        return kind;
    }

    /**
     * Sets the value of the kind property.
     * 
     * @param value
     *     allowed object is
     *     {@link ComparisonMeasure.Kind }
     *     
     */
    public void setKind(ComparisonMeasure.Kind value) {
        this.kind = value;
    }

    /**
     * Gets the value of the compareFunction property.
     * 
     * @return
     *     possible object is
     *     {@link CompareFunctionType }
     *     
     */
    public CompareFunctionType getCompareFunction() {
        if (compareFunction == null) {
            return CompareFunctionType.ABS_DIFF;
        } else {
            return compareFunction;
        }
    }

    /**
     * Sets the value of the compareFunction property.
     * 
     * @param value
     *     allowed object is
     *     {@link CompareFunctionType }
     *     
     */
    public void setCompareFunction(CompareFunctionType value) {
        this.compareFunction = value;
    }

    /**
     * Gets the value of the minimum property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getMinimum() {
        return minimum;
    }

    /**
     * Sets the value of the minimum property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setMinimum(Double value) {
        this.minimum = value;
    }

    /**
     * Gets the value of the maximum property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getMaximum() {
        return maximum;
    }

    /**
     * Sets the value of the maximum property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setMaximum(Double value) {
        this.maximum = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof ComparisonMeasure)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final ComparisonMeasure that = ((ComparisonMeasure) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            Euclidean lhsEuclidean;
            lhsEuclidean = this.getEuclidean();
            Euclidean rhsEuclidean;
            rhsEuclidean = that.getEuclidean();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "euclidean", lhsEuclidean), LocatorUtils.property(thatLocator, "euclidean", rhsEuclidean), lhsEuclidean, rhsEuclidean)) {
                return false;
            }
        }
        {
            SquaredEuclidean lhsSquaredEuclidean;
            lhsSquaredEuclidean = this.getSquaredEuclidean();
            SquaredEuclidean rhsSquaredEuclidean;
            rhsSquaredEuclidean = that.getSquaredEuclidean();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "squaredEuclidean", lhsSquaredEuclidean), LocatorUtils.property(thatLocator, "squaredEuclidean", rhsSquaredEuclidean), lhsSquaredEuclidean, rhsSquaredEuclidean)) {
                return false;
            }
        }
        {
            Chebychev lhsChebychev;
            lhsChebychev = this.getChebychev();
            Chebychev rhsChebychev;
            rhsChebychev = that.getChebychev();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "chebychev", lhsChebychev), LocatorUtils.property(thatLocator, "chebychev", rhsChebychev), lhsChebychev, rhsChebychev)) {
                return false;
            }
        }
        {
            CityBlock lhsCityBlock;
            lhsCityBlock = this.getCityBlock();
            CityBlock rhsCityBlock;
            rhsCityBlock = that.getCityBlock();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "cityBlock", lhsCityBlock), LocatorUtils.property(thatLocator, "cityBlock", rhsCityBlock), lhsCityBlock, rhsCityBlock)) {
                return false;
            }
        }
        {
            Minkowski lhsMinkowski;
            lhsMinkowski = this.getMinkowski();
            Minkowski rhsMinkowski;
            rhsMinkowski = that.getMinkowski();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "minkowski", lhsMinkowski), LocatorUtils.property(thatLocator, "minkowski", rhsMinkowski), lhsMinkowski, rhsMinkowski)) {
                return false;
            }
        }
        {
            SimpleMatching lhsSimpleMatching;
            lhsSimpleMatching = this.getSimpleMatching();
            SimpleMatching rhsSimpleMatching;
            rhsSimpleMatching = that.getSimpleMatching();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "simpleMatching", lhsSimpleMatching), LocatorUtils.property(thatLocator, "simpleMatching", rhsSimpleMatching), lhsSimpleMatching, rhsSimpleMatching)) {
                return false;
            }
        }
        {
            Jaccard lhsJaccard;
            lhsJaccard = this.getJaccard();
            Jaccard rhsJaccard;
            rhsJaccard = that.getJaccard();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "jaccard", lhsJaccard), LocatorUtils.property(thatLocator, "jaccard", rhsJaccard), lhsJaccard, rhsJaccard)) {
                return false;
            }
        }
        {
            Tanimoto lhsTanimoto;
            lhsTanimoto = this.getTanimoto();
            Tanimoto rhsTanimoto;
            rhsTanimoto = that.getTanimoto();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "tanimoto", lhsTanimoto), LocatorUtils.property(thatLocator, "tanimoto", rhsTanimoto), lhsTanimoto, rhsTanimoto)) {
                return false;
            }
        }
        {
            BinarySimilarity lhsBinarySimilarity;
            lhsBinarySimilarity = this.getBinarySimilarity();
            BinarySimilarity rhsBinarySimilarity;
            rhsBinarySimilarity = that.getBinarySimilarity();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "binarySimilarity", lhsBinarySimilarity), LocatorUtils.property(thatLocator, "binarySimilarity", rhsBinarySimilarity), lhsBinarySimilarity, rhsBinarySimilarity)) {
                return false;
            }
        }
        {
            ComparisonMeasure.Kind lhsKind;
            lhsKind = this.getKind();
            ComparisonMeasure.Kind rhsKind;
            rhsKind = that.getKind();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "kind", lhsKind), LocatorUtils.property(thatLocator, "kind", rhsKind), lhsKind, rhsKind)) {
                return false;
            }
        }
        {
            CompareFunctionType lhsCompareFunction;
            lhsCompareFunction = this.getCompareFunction();
            CompareFunctionType rhsCompareFunction;
            rhsCompareFunction = that.getCompareFunction();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "compareFunction", lhsCompareFunction), LocatorUtils.property(thatLocator, "compareFunction", rhsCompareFunction), lhsCompareFunction, rhsCompareFunction)) {
                return false;
            }
        }
        {
            Double lhsMinimum;
            lhsMinimum = this.getMinimum();
            Double rhsMinimum;
            rhsMinimum = that.getMinimum();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "minimum", lhsMinimum), LocatorUtils.property(thatLocator, "minimum", rhsMinimum), lhsMinimum, rhsMinimum)) {
                return false;
            }
        }
        {
            Double lhsMaximum;
            lhsMaximum = this.getMaximum();
            Double rhsMaximum;
            rhsMaximum = that.getMaximum();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "maximum", lhsMaximum), LocatorUtils.property(thatLocator, "maximum", rhsMaximum), lhsMaximum, rhsMaximum)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            Euclidean theEuclidean;
            theEuclidean = this.getEuclidean();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "euclidean", theEuclidean), currentHashCode, theEuclidean);
        }
        {
            SquaredEuclidean theSquaredEuclidean;
            theSquaredEuclidean = this.getSquaredEuclidean();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "squaredEuclidean", theSquaredEuclidean), currentHashCode, theSquaredEuclidean);
        }
        {
            Chebychev theChebychev;
            theChebychev = this.getChebychev();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "chebychev", theChebychev), currentHashCode, theChebychev);
        }
        {
            CityBlock theCityBlock;
            theCityBlock = this.getCityBlock();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "cityBlock", theCityBlock), currentHashCode, theCityBlock);
        }
        {
            Minkowski theMinkowski;
            theMinkowski = this.getMinkowski();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "minkowski", theMinkowski), currentHashCode, theMinkowski);
        }
        {
            SimpleMatching theSimpleMatching;
            theSimpleMatching = this.getSimpleMatching();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "simpleMatching", theSimpleMatching), currentHashCode, theSimpleMatching);
        }
        {
            Jaccard theJaccard;
            theJaccard = this.getJaccard();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "jaccard", theJaccard), currentHashCode, theJaccard);
        }
        {
            Tanimoto theTanimoto;
            theTanimoto = this.getTanimoto();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "tanimoto", theTanimoto), currentHashCode, theTanimoto);
        }
        {
            BinarySimilarity theBinarySimilarity;
            theBinarySimilarity = this.getBinarySimilarity();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "binarySimilarity", theBinarySimilarity), currentHashCode, theBinarySimilarity);
        }
        {
            ComparisonMeasure.Kind theKind;
            theKind = this.getKind();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "kind", theKind), currentHashCode, theKind);
        }
        {
            CompareFunctionType theCompareFunction;
            theCompareFunction = this.getCompareFunction();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "compareFunction", theCompareFunction), currentHashCode, theCompareFunction);
        }
        {
            Double theMinimum;
            theMinimum = this.getMinimum();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "minimum", theMinimum), currentHashCode, theMinimum);
        }
        {
            Double theMaximum;
            theMaximum = this.getMaximum();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "maximum", theMaximum), currentHashCode, theMaximum);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            Euclidean theEuclidean;
            theEuclidean = this.getEuclidean();
            strategy.appendField(locator, this, "euclidean", buffer, theEuclidean);
        }
        {
            SquaredEuclidean theSquaredEuclidean;
            theSquaredEuclidean = this.getSquaredEuclidean();
            strategy.appendField(locator, this, "squaredEuclidean", buffer, theSquaredEuclidean);
        }
        {
            Chebychev theChebychev;
            theChebychev = this.getChebychev();
            strategy.appendField(locator, this, "chebychev", buffer, theChebychev);
        }
        {
            CityBlock theCityBlock;
            theCityBlock = this.getCityBlock();
            strategy.appendField(locator, this, "cityBlock", buffer, theCityBlock);
        }
        {
            Minkowski theMinkowski;
            theMinkowski = this.getMinkowski();
            strategy.appendField(locator, this, "minkowski", buffer, theMinkowski);
        }
        {
            SimpleMatching theSimpleMatching;
            theSimpleMatching = this.getSimpleMatching();
            strategy.appendField(locator, this, "simpleMatching", buffer, theSimpleMatching);
        }
        {
            Jaccard theJaccard;
            theJaccard = this.getJaccard();
            strategy.appendField(locator, this, "jaccard", buffer, theJaccard);
        }
        {
            Tanimoto theTanimoto;
            theTanimoto = this.getTanimoto();
            strategy.appendField(locator, this, "tanimoto", buffer, theTanimoto);
        }
        {
            BinarySimilarity theBinarySimilarity;
            theBinarySimilarity = this.getBinarySimilarity();
            strategy.appendField(locator, this, "binarySimilarity", buffer, theBinarySimilarity);
        }
        {
            ComparisonMeasure.Kind theKind;
            theKind = this.getKind();
            strategy.appendField(locator, this, "kind", buffer, theKind);
        }
        {
            CompareFunctionType theCompareFunction;
            theCompareFunction = this.getCompareFunction();
            strategy.appendField(locator, this, "compareFunction", buffer, theCompareFunction);
        }
        {
            Double theMinimum;
            theMinimum = this.getMinimum();
            strategy.appendField(locator, this, "minimum", buffer, theMinimum);
        }
        {
            Double theMaximum;
            theMaximum = this.getMaximum();
            strategy.appendField(locator, this, "maximum", buffer, theMaximum);
        }
        return buffer;
    }


    /**
     * <p>Java class for null.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * <p>
     * <pre>
     * &lt;simpleType>
     *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
     *     &lt;enumeration value="distance"/>
     *     &lt;enumeration value="similarity"/>
     *   &lt;/restriction>
     * &lt;/simpleType>
     * </pre>
     * 
     */
    @XmlType(name = "")
    @XmlEnum
    public enum Kind {

        @XmlEnumValue("distance")
        DISTANCE("distance"),
        @XmlEnumValue("similarity")
        SIMILARITY("similarity");
        private final String value;

        Kind(String v) {
            value = v;
        }

        public String value() {
            return value;
        }

        public static ComparisonMeasure.Kind fromValue(String v) {
            for (ComparisonMeasure.Kind c: ComparisonMeasure.Kind.values()) {
                if (c.value.equals(v)) {
                    return c;
                }
            }
            throw new IllegalArgumentException(v);
        }

    }

}
