
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Neuron" maxOccurs="unbounded"/>
 *       &lt;/sequence>
 *       &lt;attribute name="numberOfNeurons" type="{http://www.w3.org/2001/XMLSchema}nonNegativeInteger" />
 *       &lt;attribute name="activationFunction" type="{http://www.dmg.org/PMML-4_1}ACTIVATION-FUNCTION" />
 *       &lt;attribute name="threshold" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="width" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="altitude" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="normalizationMethod" type="{http://www.dmg.org/PMML-4_1}NN-NORMALIZATION-METHOD" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "neurons"
})
@XmlRootElement(name = "NeuralLayer")
public class NeuralLayer
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "Neuron", required = true)
    protected List<Neuron> neurons;
    @XmlAttribute(name = "numberOfNeurons")
    @XmlSchemaType(name = "nonNegativeInteger")
    protected BigInteger numberOfNeurons;
    @XmlAttribute(name = "activationFunction")
    protected ActivationFunctionType activationFunction;
    @XmlAttribute(name = "threshold")
    protected Double threshold;
    @XmlAttribute(name = "width")
    protected Double width;
    @XmlAttribute(name = "altitude")
    protected Double altitude;
    @XmlAttribute(name = "normalizationMethod")
    protected NnNormalizationMethodType normalizationMethod;

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the neurons property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the neurons property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getNeurons().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Neuron }
     * 
     * 
     */
    public List<Neuron> getNeurons() {
        if (neurons == null) {
            neurons = new ArrayList<Neuron>();
        }
        return this.neurons;
    }

    /**
     * Gets the value of the numberOfNeurons property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getNumberOfNeurons() {
        return numberOfNeurons;
    }

    /**
     * Sets the value of the numberOfNeurons property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setNumberOfNeurons(BigInteger value) {
        this.numberOfNeurons = value;
    }

    /**
     * Gets the value of the activationFunction property.
     * 
     * @return
     *     possible object is
     *     {@link ActivationFunctionType }
     *     
     */
    public ActivationFunctionType getActivationFunction() {
        return activationFunction;
    }

    /**
     * Sets the value of the activationFunction property.
     * 
     * @param value
     *     allowed object is
     *     {@link ActivationFunctionType }
     *     
     */
    public void setActivationFunction(ActivationFunctionType value) {
        this.activationFunction = value;
    }

    /**
     * Gets the value of the threshold property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getThreshold() {
        return threshold;
    }

    /**
     * Sets the value of the threshold property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setThreshold(Double value) {
        this.threshold = value;
    }

    /**
     * Gets the value of the width property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getWidth() {
        return width;
    }

    /**
     * Sets the value of the width property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setWidth(Double value) {
        this.width = value;
    }

    /**
     * Gets the value of the altitude property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getAltitude() {
        return altitude;
    }

    /**
     * Sets the value of the altitude property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setAltitude(Double value) {
        this.altitude = value;
    }

    /**
     * Gets the value of the normalizationMethod property.
     * 
     * @return
     *     possible object is
     *     {@link NnNormalizationMethodType }
     *     
     */
    public NnNormalizationMethodType getNormalizationMethod() {
        return normalizationMethod;
    }

    /**
     * Sets the value of the normalizationMethod property.
     * 
     * @param value
     *     allowed object is
     *     {@link NnNormalizationMethodType }
     *     
     */
    public void setNormalizationMethod(NnNormalizationMethodType value) {
        this.normalizationMethod = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof NeuralLayer)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final NeuralLayer that = ((NeuralLayer) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            List<Neuron> lhsNeurons;
            lhsNeurons = (((this.neurons!= null)&&(!this.neurons.isEmpty()))?this.getNeurons():null);
            List<Neuron> rhsNeurons;
            rhsNeurons = (((that.neurons!= null)&&(!that.neurons.isEmpty()))?that.getNeurons():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "neurons", lhsNeurons), LocatorUtils.property(thatLocator, "neurons", rhsNeurons), lhsNeurons, rhsNeurons)) {
                return false;
            }
        }
        {
            BigInteger lhsNumberOfNeurons;
            lhsNumberOfNeurons = this.getNumberOfNeurons();
            BigInteger rhsNumberOfNeurons;
            rhsNumberOfNeurons = that.getNumberOfNeurons();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "numberOfNeurons", lhsNumberOfNeurons), LocatorUtils.property(thatLocator, "numberOfNeurons", rhsNumberOfNeurons), lhsNumberOfNeurons, rhsNumberOfNeurons)) {
                return false;
            }
        }
        {
            ActivationFunctionType lhsActivationFunction;
            lhsActivationFunction = this.getActivationFunction();
            ActivationFunctionType rhsActivationFunction;
            rhsActivationFunction = that.getActivationFunction();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "activationFunction", lhsActivationFunction), LocatorUtils.property(thatLocator, "activationFunction", rhsActivationFunction), lhsActivationFunction, rhsActivationFunction)) {
                return false;
            }
        }
        {
            Double lhsThreshold;
            lhsThreshold = this.getThreshold();
            Double rhsThreshold;
            rhsThreshold = that.getThreshold();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "threshold", lhsThreshold), LocatorUtils.property(thatLocator, "threshold", rhsThreshold), lhsThreshold, rhsThreshold)) {
                return false;
            }
        }
        {
            Double lhsWidth;
            lhsWidth = this.getWidth();
            Double rhsWidth;
            rhsWidth = that.getWidth();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "width", lhsWidth), LocatorUtils.property(thatLocator, "width", rhsWidth), lhsWidth, rhsWidth)) {
                return false;
            }
        }
        {
            Double lhsAltitude;
            lhsAltitude = this.getAltitude();
            Double rhsAltitude;
            rhsAltitude = that.getAltitude();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "altitude", lhsAltitude), LocatorUtils.property(thatLocator, "altitude", rhsAltitude), lhsAltitude, rhsAltitude)) {
                return false;
            }
        }
        {
            NnNormalizationMethodType lhsNormalizationMethod;
            lhsNormalizationMethod = this.getNormalizationMethod();
            NnNormalizationMethodType rhsNormalizationMethod;
            rhsNormalizationMethod = that.getNormalizationMethod();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "normalizationMethod", lhsNormalizationMethod), LocatorUtils.property(thatLocator, "normalizationMethod", rhsNormalizationMethod), lhsNormalizationMethod, rhsNormalizationMethod)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            List<Neuron> theNeurons;
            theNeurons = (((this.neurons!= null)&&(!this.neurons.isEmpty()))?this.getNeurons():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "neurons", theNeurons), currentHashCode, theNeurons);
        }
        {
            BigInteger theNumberOfNeurons;
            theNumberOfNeurons = this.getNumberOfNeurons();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "numberOfNeurons", theNumberOfNeurons), currentHashCode, theNumberOfNeurons);
        }
        {
            ActivationFunctionType theActivationFunction;
            theActivationFunction = this.getActivationFunction();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "activationFunction", theActivationFunction), currentHashCode, theActivationFunction);
        }
        {
            Double theThreshold;
            theThreshold = this.getThreshold();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "threshold", theThreshold), currentHashCode, theThreshold);
        }
        {
            Double theWidth;
            theWidth = this.getWidth();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "width", theWidth), currentHashCode, theWidth);
        }
        {
            Double theAltitude;
            theAltitude = this.getAltitude();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "altitude", theAltitude), currentHashCode, theAltitude);
        }
        {
            NnNormalizationMethodType theNormalizationMethod;
            theNormalizationMethod = this.getNormalizationMethod();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "normalizationMethod", theNormalizationMethod), currentHashCode, theNormalizationMethod);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            List<Neuron> theNeurons;
            theNeurons = (((this.neurons!= null)&&(!this.neurons.isEmpty()))?this.getNeurons():null);
            strategy.appendField(locator, this, "neurons", buffer, theNeurons);
        }
        {
            BigInteger theNumberOfNeurons;
            theNumberOfNeurons = this.getNumberOfNeurons();
            strategy.appendField(locator, this, "numberOfNeurons", buffer, theNumberOfNeurons);
        }
        {
            ActivationFunctionType theActivationFunction;
            theActivationFunction = this.getActivationFunction();
            strategy.appendField(locator, this, "activationFunction", buffer, theActivationFunction);
        }
        {
            Double theThreshold;
            theThreshold = this.getThreshold();
            strategy.appendField(locator, this, "threshold", buffer, theThreshold);
        }
        {
            Double theWidth;
            theWidth = this.getWidth();
            strategy.appendField(locator, this, "width", buffer, theWidth);
        }
        {
            Double theAltitude;
            theAltitude = this.getAltitude();
            strategy.appendField(locator, this, "altitude", buffer, theAltitude);
        }
        {
            NnNormalizationMethodType theNormalizationMethod;
            theNormalizationMethod = this.getNormalizationMethod();
            strategy.appendField(locator, this, "normalizationMethod", buffer, theNormalizationMethod);
        }
        return buffer;
    }

}
