
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="targetCategory" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="parameterName" use="required" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="beta" use="required" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="df" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions"
})
@XmlRootElement(name = "PCell")
public class PCell
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlAttribute(name = "targetCategory")
    protected String targetCategory;
    @XmlAttribute(name = "parameterName", required = true)
    protected String parameterName;
    @XmlAttribute(name = "beta", required = true)
    protected double beta;
    @XmlAttribute(name = "df")
    protected BigInteger df;

    @Deprecated
    public PCell() {
        super();
    }

    public PCell(final String parameterName, final double beta) {
        super();
        this.parameterName = parameterName;
        this.beta = beta;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the targetCategory property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTargetCategory() {
        return targetCategory;
    }

    /**
     * Sets the value of the targetCategory property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTargetCategory(String value) {
        this.targetCategory = value;
    }

    /**
     * Gets the value of the parameterName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getParameterName() {
        return parameterName;
    }

    /**
     * Sets the value of the parameterName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setParameterName(String value) {
        this.parameterName = value;
    }

    /**
     * Gets the value of the beta property.
     * 
     */
    public double getBeta() {
        return beta;
    }

    /**
     * Sets the value of the beta property.
     * 
     */
    public void setBeta(double value) {
        this.beta = value;
    }

    /**
     * Gets the value of the df property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getDf() {
        return df;
    }

    /**
     * Sets the value of the df property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setDf(BigInteger value) {
        this.df = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof PCell)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final PCell that = ((PCell) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            String lhsTargetCategory;
            lhsTargetCategory = this.getTargetCategory();
            String rhsTargetCategory;
            rhsTargetCategory = that.getTargetCategory();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "targetCategory", lhsTargetCategory), LocatorUtils.property(thatLocator, "targetCategory", rhsTargetCategory), lhsTargetCategory, rhsTargetCategory)) {
                return false;
            }
        }
        {
            String lhsParameterName;
            lhsParameterName = this.getParameterName();
            String rhsParameterName;
            rhsParameterName = that.getParameterName();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "parameterName", lhsParameterName), LocatorUtils.property(thatLocator, "parameterName", rhsParameterName), lhsParameterName, rhsParameterName)) {
                return false;
            }
        }
        {
            double lhsBeta;
            lhsBeta = (true?this.getBeta(): 0.0D);
            double rhsBeta;
            rhsBeta = (true?that.getBeta(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "beta", lhsBeta), LocatorUtils.property(thatLocator, "beta", rhsBeta), lhsBeta, rhsBeta)) {
                return false;
            }
        }
        {
            BigInteger lhsDf;
            lhsDf = this.getDf();
            BigInteger rhsDf;
            rhsDf = that.getDf();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "df", lhsDf), LocatorUtils.property(thatLocator, "df", rhsDf), lhsDf, rhsDf)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "targetCategory", theTargetCategory), currentHashCode, theTargetCategory);
        }
        {
            String theParameterName;
            theParameterName = this.getParameterName();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "parameterName", theParameterName), currentHashCode, theParameterName);
        }
        {
            double theBeta;
            theBeta = (true?this.getBeta(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "beta", theBeta), currentHashCode, theBeta);
        }
        {
            BigInteger theDf;
            theDf = this.getDf();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "df", theDf), currentHashCode, theDf);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            strategy.appendField(locator, this, "targetCategory", buffer, theTargetCategory);
        }
        {
            String theParameterName;
            theParameterName = this.getParameterName();
            strategy.appendField(locator, this, "parameterName", buffer, theParameterName);
        }
        {
            double theBeta;
            theBeta = (true?this.getBeta(): 0.0D);
            strategy.appendField(locator, this, "beta", buffer, theBeta);
        }
        {
            BigInteger theDf;
            theDf = this.getDf();
            strategy.appendField(locator, this, "df", buffer, theDf);
        }
        return buffer;
    }

}
