
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}MiningSchema"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}ModelStats" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}LocalTransformations" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Constraints" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Item" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Itemset" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}SetPredicate" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Sequence" maxOccurs="unbounded"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}SequenceRule" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="modelName" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="functionName" use="required" type="{http://www.dmg.org/PMML-4_1}MINING-FUNCTION" />
 *       &lt;attribute name="algorithmName" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="numberOfTransactions" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="maxNumberOfItemsPerTransaction" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="avgNumberOfItemsPerTransaction" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="numberOfTransactionGroups" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="maxNumberOfTAsPerTAGroup" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="avgNumberOfTAsPerTAGroup" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="isScorable" type="{http://www.w3.org/2001/XMLSchema}boolean" default="true" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "miningSchema",
    "modelStats",
    "localTransformations",
    "constraints",
    "items",
    "itemsets",
    "setPredicates",
    "sequences",
    "sequenceRules"
})
@XmlRootElement(name = "SequenceModel")
public class SequenceModel
    extends Model
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "MiningSchema", required = true)
    protected MiningSchema miningSchema;
    @XmlElement(name = "ModelStats")
    protected ModelStats modelStats;
    @XmlElement(name = "LocalTransformations")
    protected LocalTransformations localTransformations;
    @XmlElement(name = "Constraints")
    protected Constraints constraints;
    @XmlElement(name = "Item")
    protected List<Item> items;
    @XmlElement(name = "Itemset")
    protected List<Itemset> itemsets;
    @XmlElement(name = "SetPredicate")
    protected List<SetPredicate> setPredicates;
    @XmlElement(name = "Sequence", required = true)
    protected List<Sequence> sequences;
    @XmlElement(name = "SequenceRule")
    protected List<SequenceRule> sequenceRules;
    @XmlAttribute(name = "modelName")
    protected String modelName;
    @XmlAttribute(name = "functionName", required = true)
    protected MiningFunctionType functionName;
    @XmlAttribute(name = "algorithmName")
    protected String algorithmName;
    @XmlAttribute(name = "numberOfTransactions")
    protected BigInteger numberOfTransactions;
    @XmlAttribute(name = "maxNumberOfItemsPerTransaction")
    protected BigInteger maxNumberOfItemsPerTransaction;
    @XmlAttribute(name = "avgNumberOfItemsPerTransaction")
    protected Double avgNumberOfItemsPerTransaction;
    @XmlAttribute(name = "numberOfTransactionGroups")
    protected BigInteger numberOfTransactionGroups;
    @XmlAttribute(name = "maxNumberOfTAsPerTAGroup")
    protected BigInteger maxNumberOfTAsPerTAGroup;
    @XmlAttribute(name = "avgNumberOfTAsPerTAGroup")
    protected Double avgNumberOfTAsPerTAGroup;
    @XmlAttribute(name = "isScorable")
    protected Boolean scorable;

    @Deprecated
    public SequenceModel() {
        super();
    }

    public SequenceModel(final MiningSchema miningSchema, final MiningFunctionType functionName) {
        super();
        this.miningSchema = miningSchema;
        this.functionName = functionName;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the miningSchema property.
     * 
     * @return
     *     possible object is
     *     {@link MiningSchema }
     *     
     */
    public MiningSchema getMiningSchema() {
        return miningSchema;
    }

    /**
     * Sets the value of the miningSchema property.
     * 
     * @param value
     *     allowed object is
     *     {@link MiningSchema }
     *     
     */
    public void setMiningSchema(MiningSchema value) {
        this.miningSchema = value;
    }

    /**
     * Gets the value of the modelStats property.
     * 
     * @return
     *     possible object is
     *     {@link ModelStats }
     *     
     */
    public ModelStats getModelStats() {
        return modelStats;
    }

    /**
     * Sets the value of the modelStats property.
     * 
     * @param value
     *     allowed object is
     *     {@link ModelStats }
     *     
     */
    public void setModelStats(ModelStats value) {
        this.modelStats = value;
    }

    /**
     * Gets the value of the localTransformations property.
     * 
     * @return
     *     possible object is
     *     {@link LocalTransformations }
     *     
     */
    public LocalTransformations getLocalTransformations() {
        return localTransformations;
    }

    /**
     * Sets the value of the localTransformations property.
     * 
     * @param value
     *     allowed object is
     *     {@link LocalTransformations }
     *     
     */
    public void setLocalTransformations(LocalTransformations value) {
        this.localTransformations = value;
    }

    /**
     * Gets the value of the constraints property.
     * 
     * @return
     *     possible object is
     *     {@link Constraints }
     *     
     */
    public Constraints getConstraints() {
        return constraints;
    }

    /**
     * Sets the value of the constraints property.
     * 
     * @param value
     *     allowed object is
     *     {@link Constraints }
     *     
     */
    public void setConstraints(Constraints value) {
        this.constraints = value;
    }

    /**
     * Gets the value of the items property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the items property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getItems().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Item }
     * 
     * 
     */
    public List<Item> getItems() {
        if (items == null) {
            items = new ArrayList<Item>();
        }
        return this.items;
    }

    /**
     * Gets the value of the itemsets property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the itemsets property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getItemsets().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Itemset }
     * 
     * 
     */
    public List<Itemset> getItemsets() {
        if (itemsets == null) {
            itemsets = new ArrayList<Itemset>();
        }
        return this.itemsets;
    }

    /**
     * Gets the value of the setPredicates property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the setPredicates property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSetPredicates().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link SetPredicate }
     * 
     * 
     */
    public List<SetPredicate> getSetPredicates() {
        if (setPredicates == null) {
            setPredicates = new ArrayList<SetPredicate>();
        }
        return this.setPredicates;
    }

    /**
     * Gets the value of the sequences property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the sequences property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSequences().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Sequence }
     * 
     * 
     */
    public List<Sequence> getSequences() {
        if (sequences == null) {
            sequences = new ArrayList<Sequence>();
        }
        return this.sequences;
    }

    /**
     * Gets the value of the sequenceRules property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the sequenceRules property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSequenceRules().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link SequenceRule }
     * 
     * 
     */
    public List<SequenceRule> getSequenceRules() {
        if (sequenceRules == null) {
            sequenceRules = new ArrayList<SequenceRule>();
        }
        return this.sequenceRules;
    }

    /**
     * Gets the value of the modelName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getModelName() {
        return modelName;
    }

    /**
     * Sets the value of the modelName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setModelName(String value) {
        this.modelName = value;
    }

    /**
     * Gets the value of the functionName property.
     * 
     * @return
     *     possible object is
     *     {@link MiningFunctionType }
     *     
     */
    public MiningFunctionType getFunctionName() {
        return functionName;
    }

    /**
     * Sets the value of the functionName property.
     * 
     * @param value
     *     allowed object is
     *     {@link MiningFunctionType }
     *     
     */
    public void setFunctionName(MiningFunctionType value) {
        this.functionName = value;
    }

    /**
     * Gets the value of the algorithmName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getAlgorithmName() {
        return algorithmName;
    }

    /**
     * Sets the value of the algorithmName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAlgorithmName(String value) {
        this.algorithmName = value;
    }

    /**
     * Gets the value of the numberOfTransactions property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getNumberOfTransactions() {
        return numberOfTransactions;
    }

    /**
     * Sets the value of the numberOfTransactions property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setNumberOfTransactions(BigInteger value) {
        this.numberOfTransactions = value;
    }

    /**
     * Gets the value of the maxNumberOfItemsPerTransaction property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getMaxNumberOfItemsPerTransaction() {
        return maxNumberOfItemsPerTransaction;
    }

    /**
     * Sets the value of the maxNumberOfItemsPerTransaction property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setMaxNumberOfItemsPerTransaction(BigInteger value) {
        this.maxNumberOfItemsPerTransaction = value;
    }

    /**
     * Gets the value of the avgNumberOfItemsPerTransaction property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getAvgNumberOfItemsPerTransaction() {
        return avgNumberOfItemsPerTransaction;
    }

    /**
     * Sets the value of the avgNumberOfItemsPerTransaction property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setAvgNumberOfItemsPerTransaction(Double value) {
        this.avgNumberOfItemsPerTransaction = value;
    }

    /**
     * Gets the value of the numberOfTransactionGroups property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getNumberOfTransactionGroups() {
        return numberOfTransactionGroups;
    }

    /**
     * Sets the value of the numberOfTransactionGroups property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setNumberOfTransactionGroups(BigInteger value) {
        this.numberOfTransactionGroups = value;
    }

    /**
     * Gets the value of the maxNumberOfTAsPerTAGroup property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getMaxNumberOfTAsPerTAGroup() {
        return maxNumberOfTAsPerTAGroup;
    }

    /**
     * Sets the value of the maxNumberOfTAsPerTAGroup property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setMaxNumberOfTAsPerTAGroup(BigInteger value) {
        this.maxNumberOfTAsPerTAGroup = value;
    }

    /**
     * Gets the value of the avgNumberOfTAsPerTAGroup property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getAvgNumberOfTAsPerTAGroup() {
        return avgNumberOfTAsPerTAGroup;
    }

    /**
     * Sets the value of the avgNumberOfTAsPerTAGroup property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setAvgNumberOfTAsPerTAGroup(Double value) {
        this.avgNumberOfTAsPerTAGroup = value;
    }

    /**
     * Gets the value of the scorable property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isScorable() {
        if (scorable == null) {
            return true;
        } else {
            return scorable;
        }
    }

    /**
     * Sets the value of the scorable property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setScorable(Boolean value) {
        this.scorable = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof SequenceModel)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final SequenceModel that = ((SequenceModel) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            MiningSchema lhsMiningSchema;
            lhsMiningSchema = this.getMiningSchema();
            MiningSchema rhsMiningSchema;
            rhsMiningSchema = that.getMiningSchema();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "miningSchema", lhsMiningSchema), LocatorUtils.property(thatLocator, "miningSchema", rhsMiningSchema), lhsMiningSchema, rhsMiningSchema)) {
                return false;
            }
        }
        {
            ModelStats lhsModelStats;
            lhsModelStats = this.getModelStats();
            ModelStats rhsModelStats;
            rhsModelStats = that.getModelStats();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "modelStats", lhsModelStats), LocatorUtils.property(thatLocator, "modelStats", rhsModelStats), lhsModelStats, rhsModelStats)) {
                return false;
            }
        }
        {
            LocalTransformations lhsLocalTransformations;
            lhsLocalTransformations = this.getLocalTransformations();
            LocalTransformations rhsLocalTransformations;
            rhsLocalTransformations = that.getLocalTransformations();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "localTransformations", lhsLocalTransformations), LocatorUtils.property(thatLocator, "localTransformations", rhsLocalTransformations), lhsLocalTransformations, rhsLocalTransformations)) {
                return false;
            }
        }
        {
            Constraints lhsConstraints;
            lhsConstraints = this.getConstraints();
            Constraints rhsConstraints;
            rhsConstraints = that.getConstraints();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "constraints", lhsConstraints), LocatorUtils.property(thatLocator, "constraints", rhsConstraints), lhsConstraints, rhsConstraints)) {
                return false;
            }
        }
        {
            List<Item> lhsItems;
            lhsItems = (((this.items!= null)&&(!this.items.isEmpty()))?this.getItems():null);
            List<Item> rhsItems;
            rhsItems = (((that.items!= null)&&(!that.items.isEmpty()))?that.getItems():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "items", lhsItems), LocatorUtils.property(thatLocator, "items", rhsItems), lhsItems, rhsItems)) {
                return false;
            }
        }
        {
            List<Itemset> lhsItemsets;
            lhsItemsets = (((this.itemsets!= null)&&(!this.itemsets.isEmpty()))?this.getItemsets():null);
            List<Itemset> rhsItemsets;
            rhsItemsets = (((that.itemsets!= null)&&(!that.itemsets.isEmpty()))?that.getItemsets():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "itemsets", lhsItemsets), LocatorUtils.property(thatLocator, "itemsets", rhsItemsets), lhsItemsets, rhsItemsets)) {
                return false;
            }
        }
        {
            List<SetPredicate> lhsSetPredicates;
            lhsSetPredicates = (((this.setPredicates!= null)&&(!this.setPredicates.isEmpty()))?this.getSetPredicates():null);
            List<SetPredicate> rhsSetPredicates;
            rhsSetPredicates = (((that.setPredicates!= null)&&(!that.setPredicates.isEmpty()))?that.getSetPredicates():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "setPredicates", lhsSetPredicates), LocatorUtils.property(thatLocator, "setPredicates", rhsSetPredicates), lhsSetPredicates, rhsSetPredicates)) {
                return false;
            }
        }
        {
            List<Sequence> lhsSequences;
            lhsSequences = (((this.sequences!= null)&&(!this.sequences.isEmpty()))?this.getSequences():null);
            List<Sequence> rhsSequences;
            rhsSequences = (((that.sequences!= null)&&(!that.sequences.isEmpty()))?that.getSequences():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "sequences", lhsSequences), LocatorUtils.property(thatLocator, "sequences", rhsSequences), lhsSequences, rhsSequences)) {
                return false;
            }
        }
        {
            List<SequenceRule> lhsSequenceRules;
            lhsSequenceRules = (((this.sequenceRules!= null)&&(!this.sequenceRules.isEmpty()))?this.getSequenceRules():null);
            List<SequenceRule> rhsSequenceRules;
            rhsSequenceRules = (((that.sequenceRules!= null)&&(!that.sequenceRules.isEmpty()))?that.getSequenceRules():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "sequenceRules", lhsSequenceRules), LocatorUtils.property(thatLocator, "sequenceRules", rhsSequenceRules), lhsSequenceRules, rhsSequenceRules)) {
                return false;
            }
        }
        {
            String lhsModelName;
            lhsModelName = this.getModelName();
            String rhsModelName;
            rhsModelName = that.getModelName();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "modelName", lhsModelName), LocatorUtils.property(thatLocator, "modelName", rhsModelName), lhsModelName, rhsModelName)) {
                return false;
            }
        }
        {
            MiningFunctionType lhsFunctionName;
            lhsFunctionName = this.getFunctionName();
            MiningFunctionType rhsFunctionName;
            rhsFunctionName = that.getFunctionName();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "functionName", lhsFunctionName), LocatorUtils.property(thatLocator, "functionName", rhsFunctionName), lhsFunctionName, rhsFunctionName)) {
                return false;
            }
        }
        {
            String lhsAlgorithmName;
            lhsAlgorithmName = this.getAlgorithmName();
            String rhsAlgorithmName;
            rhsAlgorithmName = that.getAlgorithmName();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "algorithmName", lhsAlgorithmName), LocatorUtils.property(thatLocator, "algorithmName", rhsAlgorithmName), lhsAlgorithmName, rhsAlgorithmName)) {
                return false;
            }
        }
        {
            BigInteger lhsNumberOfTransactions;
            lhsNumberOfTransactions = this.getNumberOfTransactions();
            BigInteger rhsNumberOfTransactions;
            rhsNumberOfTransactions = that.getNumberOfTransactions();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "numberOfTransactions", lhsNumberOfTransactions), LocatorUtils.property(thatLocator, "numberOfTransactions", rhsNumberOfTransactions), lhsNumberOfTransactions, rhsNumberOfTransactions)) {
                return false;
            }
        }
        {
            BigInteger lhsMaxNumberOfItemsPerTransaction;
            lhsMaxNumberOfItemsPerTransaction = this.getMaxNumberOfItemsPerTransaction();
            BigInteger rhsMaxNumberOfItemsPerTransaction;
            rhsMaxNumberOfItemsPerTransaction = that.getMaxNumberOfItemsPerTransaction();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "maxNumberOfItemsPerTransaction", lhsMaxNumberOfItemsPerTransaction), LocatorUtils.property(thatLocator, "maxNumberOfItemsPerTransaction", rhsMaxNumberOfItemsPerTransaction), lhsMaxNumberOfItemsPerTransaction, rhsMaxNumberOfItemsPerTransaction)) {
                return false;
            }
        }
        {
            Double lhsAvgNumberOfItemsPerTransaction;
            lhsAvgNumberOfItemsPerTransaction = this.getAvgNumberOfItemsPerTransaction();
            Double rhsAvgNumberOfItemsPerTransaction;
            rhsAvgNumberOfItemsPerTransaction = that.getAvgNumberOfItemsPerTransaction();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "avgNumberOfItemsPerTransaction", lhsAvgNumberOfItemsPerTransaction), LocatorUtils.property(thatLocator, "avgNumberOfItemsPerTransaction", rhsAvgNumberOfItemsPerTransaction), lhsAvgNumberOfItemsPerTransaction, rhsAvgNumberOfItemsPerTransaction)) {
                return false;
            }
        }
        {
            BigInteger lhsNumberOfTransactionGroups;
            lhsNumberOfTransactionGroups = this.getNumberOfTransactionGroups();
            BigInteger rhsNumberOfTransactionGroups;
            rhsNumberOfTransactionGroups = that.getNumberOfTransactionGroups();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "numberOfTransactionGroups", lhsNumberOfTransactionGroups), LocatorUtils.property(thatLocator, "numberOfTransactionGroups", rhsNumberOfTransactionGroups), lhsNumberOfTransactionGroups, rhsNumberOfTransactionGroups)) {
                return false;
            }
        }
        {
            BigInteger lhsMaxNumberOfTAsPerTAGroup;
            lhsMaxNumberOfTAsPerTAGroup = this.getMaxNumberOfTAsPerTAGroup();
            BigInteger rhsMaxNumberOfTAsPerTAGroup;
            rhsMaxNumberOfTAsPerTAGroup = that.getMaxNumberOfTAsPerTAGroup();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "maxNumberOfTAsPerTAGroup", lhsMaxNumberOfTAsPerTAGroup), LocatorUtils.property(thatLocator, "maxNumberOfTAsPerTAGroup", rhsMaxNumberOfTAsPerTAGroup), lhsMaxNumberOfTAsPerTAGroup, rhsMaxNumberOfTAsPerTAGroup)) {
                return false;
            }
        }
        {
            Double lhsAvgNumberOfTAsPerTAGroup;
            lhsAvgNumberOfTAsPerTAGroup = this.getAvgNumberOfTAsPerTAGroup();
            Double rhsAvgNumberOfTAsPerTAGroup;
            rhsAvgNumberOfTAsPerTAGroup = that.getAvgNumberOfTAsPerTAGroup();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "avgNumberOfTAsPerTAGroup", lhsAvgNumberOfTAsPerTAGroup), LocatorUtils.property(thatLocator, "avgNumberOfTAsPerTAGroup", rhsAvgNumberOfTAsPerTAGroup), lhsAvgNumberOfTAsPerTAGroup, rhsAvgNumberOfTAsPerTAGroup)) {
                return false;
            }
        }
        {
            boolean lhsScorable;
            lhsScorable = ((this.scorable!= null)?this.isScorable():false);
            boolean rhsScorable;
            rhsScorable = ((that.scorable!= null)?that.isScorable():false);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "scorable", lhsScorable), LocatorUtils.property(thatLocator, "scorable", rhsScorable), lhsScorable, rhsScorable)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            MiningSchema theMiningSchema;
            theMiningSchema = this.getMiningSchema();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "miningSchema", theMiningSchema), currentHashCode, theMiningSchema);
        }
        {
            ModelStats theModelStats;
            theModelStats = this.getModelStats();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "modelStats", theModelStats), currentHashCode, theModelStats);
        }
        {
            LocalTransformations theLocalTransformations;
            theLocalTransformations = this.getLocalTransformations();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "localTransformations", theLocalTransformations), currentHashCode, theLocalTransformations);
        }
        {
            Constraints theConstraints;
            theConstraints = this.getConstraints();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "constraints", theConstraints), currentHashCode, theConstraints);
        }
        {
            List<Item> theItems;
            theItems = (((this.items!= null)&&(!this.items.isEmpty()))?this.getItems():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "items", theItems), currentHashCode, theItems);
        }
        {
            List<Itemset> theItemsets;
            theItemsets = (((this.itemsets!= null)&&(!this.itemsets.isEmpty()))?this.getItemsets():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "itemsets", theItemsets), currentHashCode, theItemsets);
        }
        {
            List<SetPredicate> theSetPredicates;
            theSetPredicates = (((this.setPredicates!= null)&&(!this.setPredicates.isEmpty()))?this.getSetPredicates():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "setPredicates", theSetPredicates), currentHashCode, theSetPredicates);
        }
        {
            List<Sequence> theSequences;
            theSequences = (((this.sequences!= null)&&(!this.sequences.isEmpty()))?this.getSequences():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "sequences", theSequences), currentHashCode, theSequences);
        }
        {
            List<SequenceRule> theSequenceRules;
            theSequenceRules = (((this.sequenceRules!= null)&&(!this.sequenceRules.isEmpty()))?this.getSequenceRules():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "sequenceRules", theSequenceRules), currentHashCode, theSequenceRules);
        }
        {
            String theModelName;
            theModelName = this.getModelName();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "modelName", theModelName), currentHashCode, theModelName);
        }
        {
            MiningFunctionType theFunctionName;
            theFunctionName = this.getFunctionName();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "functionName", theFunctionName), currentHashCode, theFunctionName);
        }
        {
            String theAlgorithmName;
            theAlgorithmName = this.getAlgorithmName();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "algorithmName", theAlgorithmName), currentHashCode, theAlgorithmName);
        }
        {
            BigInteger theNumberOfTransactions;
            theNumberOfTransactions = this.getNumberOfTransactions();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "numberOfTransactions", theNumberOfTransactions), currentHashCode, theNumberOfTransactions);
        }
        {
            BigInteger theMaxNumberOfItemsPerTransaction;
            theMaxNumberOfItemsPerTransaction = this.getMaxNumberOfItemsPerTransaction();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "maxNumberOfItemsPerTransaction", theMaxNumberOfItemsPerTransaction), currentHashCode, theMaxNumberOfItemsPerTransaction);
        }
        {
            Double theAvgNumberOfItemsPerTransaction;
            theAvgNumberOfItemsPerTransaction = this.getAvgNumberOfItemsPerTransaction();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "avgNumberOfItemsPerTransaction", theAvgNumberOfItemsPerTransaction), currentHashCode, theAvgNumberOfItemsPerTransaction);
        }
        {
            BigInteger theNumberOfTransactionGroups;
            theNumberOfTransactionGroups = this.getNumberOfTransactionGroups();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "numberOfTransactionGroups", theNumberOfTransactionGroups), currentHashCode, theNumberOfTransactionGroups);
        }
        {
            BigInteger theMaxNumberOfTAsPerTAGroup;
            theMaxNumberOfTAsPerTAGroup = this.getMaxNumberOfTAsPerTAGroup();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "maxNumberOfTAsPerTAGroup", theMaxNumberOfTAsPerTAGroup), currentHashCode, theMaxNumberOfTAsPerTAGroup);
        }
        {
            Double theAvgNumberOfTAsPerTAGroup;
            theAvgNumberOfTAsPerTAGroup = this.getAvgNumberOfTAsPerTAGroup();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "avgNumberOfTAsPerTAGroup", theAvgNumberOfTAsPerTAGroup), currentHashCode, theAvgNumberOfTAsPerTAGroup);
        }
        {
            boolean theScorable;
            theScorable = ((this.scorable!= null)?this.isScorable():false);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "scorable", theScorable), currentHashCode, theScorable);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            MiningSchema theMiningSchema;
            theMiningSchema = this.getMiningSchema();
            strategy.appendField(locator, this, "miningSchema", buffer, theMiningSchema);
        }
        {
            ModelStats theModelStats;
            theModelStats = this.getModelStats();
            strategy.appendField(locator, this, "modelStats", buffer, theModelStats);
        }
        {
            LocalTransformations theLocalTransformations;
            theLocalTransformations = this.getLocalTransformations();
            strategy.appendField(locator, this, "localTransformations", buffer, theLocalTransformations);
        }
        {
            Constraints theConstraints;
            theConstraints = this.getConstraints();
            strategy.appendField(locator, this, "constraints", buffer, theConstraints);
        }
        {
            List<Item> theItems;
            theItems = (((this.items!= null)&&(!this.items.isEmpty()))?this.getItems():null);
            strategy.appendField(locator, this, "items", buffer, theItems);
        }
        {
            List<Itemset> theItemsets;
            theItemsets = (((this.itemsets!= null)&&(!this.itemsets.isEmpty()))?this.getItemsets():null);
            strategy.appendField(locator, this, "itemsets", buffer, theItemsets);
        }
        {
            List<SetPredicate> theSetPredicates;
            theSetPredicates = (((this.setPredicates!= null)&&(!this.setPredicates.isEmpty()))?this.getSetPredicates():null);
            strategy.appendField(locator, this, "setPredicates", buffer, theSetPredicates);
        }
        {
            List<Sequence> theSequences;
            theSequences = (((this.sequences!= null)&&(!this.sequences.isEmpty()))?this.getSequences():null);
            strategy.appendField(locator, this, "sequences", buffer, theSequences);
        }
        {
            List<SequenceRule> theSequenceRules;
            theSequenceRules = (((this.sequenceRules!= null)&&(!this.sequenceRules.isEmpty()))?this.getSequenceRules():null);
            strategy.appendField(locator, this, "sequenceRules", buffer, theSequenceRules);
        }
        {
            String theModelName;
            theModelName = this.getModelName();
            strategy.appendField(locator, this, "modelName", buffer, theModelName);
        }
        {
            MiningFunctionType theFunctionName;
            theFunctionName = this.getFunctionName();
            strategy.appendField(locator, this, "functionName", buffer, theFunctionName);
        }
        {
            String theAlgorithmName;
            theAlgorithmName = this.getAlgorithmName();
            strategy.appendField(locator, this, "algorithmName", buffer, theAlgorithmName);
        }
        {
            BigInteger theNumberOfTransactions;
            theNumberOfTransactions = this.getNumberOfTransactions();
            strategy.appendField(locator, this, "numberOfTransactions", buffer, theNumberOfTransactions);
        }
        {
            BigInteger theMaxNumberOfItemsPerTransaction;
            theMaxNumberOfItemsPerTransaction = this.getMaxNumberOfItemsPerTransaction();
            strategy.appendField(locator, this, "maxNumberOfItemsPerTransaction", buffer, theMaxNumberOfItemsPerTransaction);
        }
        {
            Double theAvgNumberOfItemsPerTransaction;
            theAvgNumberOfItemsPerTransaction = this.getAvgNumberOfItemsPerTransaction();
            strategy.appendField(locator, this, "avgNumberOfItemsPerTransaction", buffer, theAvgNumberOfItemsPerTransaction);
        }
        {
            BigInteger theNumberOfTransactionGroups;
            theNumberOfTransactionGroups = this.getNumberOfTransactionGroups();
            strategy.appendField(locator, this, "numberOfTransactionGroups", buffer, theNumberOfTransactionGroups);
        }
        {
            BigInteger theMaxNumberOfTAsPerTAGroup;
            theMaxNumberOfTAsPerTAGroup = this.getMaxNumberOfTAsPerTAGroup();
            strategy.appendField(locator, this, "maxNumberOfTAsPerTAGroup", buffer, theMaxNumberOfTAsPerTAGroup);
        }
        {
            Double theAvgNumberOfTAsPerTAGroup;
            theAvgNumberOfTAsPerTAGroup = this.getAvgNumberOfTAsPerTAGroup();
            strategy.appendField(locator, this, "avgNumberOfTAsPerTAGroup", buffer, theAvgNumberOfTAsPerTAGroup);
        }
        {
            boolean theScorable;
            theScorable = ((this.scorable!= null)?this.isScorable():false);
            strategy.appendField(locator, this, "scorable", buffer, theScorable);
        }
        return buffer;
    }

    public Output getOutput() {
        throw new UnsupportedOperationException();
    }

    public void setOutput(Output output) {
        throw new UnsupportedOperationException();
    }

}
