
package org.dmg.pmml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}SupportVectors" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Coefficients"/>
 *       &lt;/sequence>
 *       &lt;attribute name="targetCategory" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="alternateTargetCategory" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="threshold" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "supportVectors",
    "coefficients"
})
@XmlRootElement(name = "SupportVectorMachine")
public class SupportVectorMachine
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElement(name = "SupportVectors")
    protected SupportVectors supportVectors;
    @XmlElement(name = "Coefficients", required = true)
    protected Coefficients coefficients;
    @XmlAttribute(name = "targetCategory")
    protected String targetCategory;
    @XmlAttribute(name = "alternateTargetCategory")
    protected String alternateTargetCategory;
    @XmlAttribute(name = "threshold")
    protected Double threshold;

    @Deprecated
    public SupportVectorMachine() {
        super();
    }

    public SupportVectorMachine(final Coefficients coefficients) {
        super();
        this.coefficients = coefficients;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the supportVectors property.
     * 
     * @return
     *     possible object is
     *     {@link SupportVectors }
     *     
     */
    public SupportVectors getSupportVectors() {
        return supportVectors;
    }

    /**
     * Sets the value of the supportVectors property.
     * 
     * @param value
     *     allowed object is
     *     {@link SupportVectors }
     *     
     */
    public void setSupportVectors(SupportVectors value) {
        this.supportVectors = value;
    }

    /**
     * Gets the value of the coefficients property.
     * 
     * @return
     *     possible object is
     *     {@link Coefficients }
     *     
     */
    public Coefficients getCoefficients() {
        return coefficients;
    }

    /**
     * Sets the value of the coefficients property.
     * 
     * @param value
     *     allowed object is
     *     {@link Coefficients }
     *     
     */
    public void setCoefficients(Coefficients value) {
        this.coefficients = value;
    }

    /**
     * Gets the value of the targetCategory property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTargetCategory() {
        return targetCategory;
    }

    /**
     * Sets the value of the targetCategory property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTargetCategory(String value) {
        this.targetCategory = value;
    }

    /**
     * Gets the value of the alternateTargetCategory property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getAlternateTargetCategory() {
        return alternateTargetCategory;
    }

    /**
     * Sets the value of the alternateTargetCategory property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAlternateTargetCategory(String value) {
        this.alternateTargetCategory = value;
    }

    /**
     * Gets the value of the threshold property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getThreshold() {
        return threshold;
    }

    /**
     * Sets the value of the threshold property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setThreshold(Double value) {
        this.threshold = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof SupportVectorMachine)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final SupportVectorMachine that = ((SupportVectorMachine) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            SupportVectors lhsSupportVectors;
            lhsSupportVectors = this.getSupportVectors();
            SupportVectors rhsSupportVectors;
            rhsSupportVectors = that.getSupportVectors();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "supportVectors", lhsSupportVectors), LocatorUtils.property(thatLocator, "supportVectors", rhsSupportVectors), lhsSupportVectors, rhsSupportVectors)) {
                return false;
            }
        }
        {
            Coefficients lhsCoefficients;
            lhsCoefficients = this.getCoefficients();
            Coefficients rhsCoefficients;
            rhsCoefficients = that.getCoefficients();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "coefficients", lhsCoefficients), LocatorUtils.property(thatLocator, "coefficients", rhsCoefficients), lhsCoefficients, rhsCoefficients)) {
                return false;
            }
        }
        {
            String lhsTargetCategory;
            lhsTargetCategory = this.getTargetCategory();
            String rhsTargetCategory;
            rhsTargetCategory = that.getTargetCategory();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "targetCategory", lhsTargetCategory), LocatorUtils.property(thatLocator, "targetCategory", rhsTargetCategory), lhsTargetCategory, rhsTargetCategory)) {
                return false;
            }
        }
        {
            String lhsAlternateTargetCategory;
            lhsAlternateTargetCategory = this.getAlternateTargetCategory();
            String rhsAlternateTargetCategory;
            rhsAlternateTargetCategory = that.getAlternateTargetCategory();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "alternateTargetCategory", lhsAlternateTargetCategory), LocatorUtils.property(thatLocator, "alternateTargetCategory", rhsAlternateTargetCategory), lhsAlternateTargetCategory, rhsAlternateTargetCategory)) {
                return false;
            }
        }
        {
            Double lhsThreshold;
            lhsThreshold = this.getThreshold();
            Double rhsThreshold;
            rhsThreshold = that.getThreshold();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "threshold", lhsThreshold), LocatorUtils.property(thatLocator, "threshold", rhsThreshold), lhsThreshold, rhsThreshold)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            SupportVectors theSupportVectors;
            theSupportVectors = this.getSupportVectors();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "supportVectors", theSupportVectors), currentHashCode, theSupportVectors);
        }
        {
            Coefficients theCoefficients;
            theCoefficients = this.getCoefficients();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "coefficients", theCoefficients), currentHashCode, theCoefficients);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "targetCategory", theTargetCategory), currentHashCode, theTargetCategory);
        }
        {
            String theAlternateTargetCategory;
            theAlternateTargetCategory = this.getAlternateTargetCategory();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "alternateTargetCategory", theAlternateTargetCategory), currentHashCode, theAlternateTargetCategory);
        }
        {
            Double theThreshold;
            theThreshold = this.getThreshold();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "threshold", theThreshold), currentHashCode, theThreshold);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            SupportVectors theSupportVectors;
            theSupportVectors = this.getSupportVectors();
            strategy.appendField(locator, this, "supportVectors", buffer, theSupportVectors);
        }
        {
            Coefficients theCoefficients;
            theCoefficients = this.getCoefficients();
            strategy.appendField(locator, this, "coefficients", buffer, theCoefficients);
        }
        {
            String theTargetCategory;
            theTargetCategory = this.getTargetCategory();
            strategy.appendField(locator, this, "targetCategory", buffer, theTargetCategory);
        }
        {
            String theAlternateTargetCategory;
            theAlternateTargetCategory = this.getAlternateTargetCategory();
            strategy.appendField(locator, this, "alternateTargetCategory", buffer, theAlternateTargetCategory);
        }
        {
            Double theThreshold;
            theThreshold = this.getThreshold();
            strategy.appendField(locator, this, "threshold", buffer, theThreshold);
        }
        return buffer;
    }

}
